/***************************************************************************
 *             __________               __   ___.
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 * $Id: ata.h,v 1.2 2002/04/27 14:19:00 zagor Exp $
 *
 * Copyright (C) 2002 by Alan Korr
 *
 * All files in this archive are subject to the GNU General Public License.
 * See the file COPYING in the source tree root for full license agreement.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/
#ifndef __ATA_H__
#define __ATA_H__

/*
  ata_spindown() time values:
   -1     Immediate spindown
   0      Timeout disabled
   1-240  (time * 5) seconds
   241-251((time - 240) * 30) minutes
   252    21 minutes
   253    Period between 8 and 12 hrs
   254    Reserved
   255    21 min 15 s
*/
extern int ata_spindown(int time);
extern int ata_hard_reset(void);
extern int ata_soft_reset(void);
extern int ata_init(void);
extern int ata_read_sectors(unsigned long start,
                            unsigned char count,
                            void* buf);
extern int ata_write_sectors(unsigned long start,
                             unsigned char count,
                             void* buf);

#endif
